# Dictionary holding configurations for various Docker containers
const container_configs = Dict(
    "fact_air" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_air:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_air", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3310")]
            )
        )
    ),
    "fact_bldgs" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_bldgs:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_bldgs", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3315")]
            )
        )
    ),
    "fact_elevation" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_elevation:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "5000/tcp" => [Dict("HostPort" => "5003")]
            )
        )
    ),
    "fact_geo" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_geo:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_geo", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3307")]
            )
        )
    ),
    "fact_jobs" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_jobs:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_jobs", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3308")]
            )
        )
    ),
    "fact_lulc" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_lulc:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "5000/tcp" => [Dict("HostPort" => "5004")]
            )
        )
    ),
    "fact_mine" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_mine:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_mine", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3314")]
            )
        )
    ),
    "fact_population" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_population:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_population", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3309")]
            )
        )
    ),
    "fact_ports" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_ports:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_ports", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3312")]
            )
        )
    ),
    "fact_power" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_power:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_power", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3313")]
            )
        )
    ),
    "fact_rail" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_rail:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "Env" => ["MARIADB_DATABASE=FACT_rail", "MYSQL_ROOT_PASSWORD=devops"],
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "3306/tcp" => [Dict("HostPort" => "3311")]
            )
        )
    ),
    "fact_road_eu" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_road_eu:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "5000/tcp" => [Dict("HostPort" => "5001")]
            )
        )
    ),
    "fact_road_na" => Dict(
        "Image" => "registry.git.nilu.no/fact/data/fact_road_na:latest",
        "Tty" => true,
        "AttachStdin" => true,
        "AttachStdout" => true,
        "AttachStderr" => true,
        "HostConfig" => Dict(
            "PortBindings" => Dict(
                "5000/tcp" => [Dict("HostPort" => "5002")]
            )
        )
    )
)

"""
get_data_container_config(service_name::String)

Retrieve Docker container configuration for a specified data service name. If the service name does not exist within the predefined configurations, an error is raised.

# Arguments
- service_name: The name of the service for which the Docker container configuration is requested.

# Returns
- A dictionary containing the Docker container configuration for the specified data service.

# Example
> config = get_data_container_config("fact_results")

This retrieves the Docker container configuration for the `fact_results` service.

# Errors
Throws an error if no configuration is found for the specified service_name.
"""
function get_data_container_config(service_name::String)
    config = get(container_configs, service_name, nothing)
    if isnothing(config)
        error("No configuration found for service: $service_name")
    end
    return config
end